/*
 * @Description: Description
 * @Author: ranli
 * @Date: 2020-09-27 16:02:56
 * @LastEditTime: 2021-04-29 17:21:35
 * @LastEditors: ranli
 */
const express = require("express");
const router = express.Router();
const fs = require("fs");
const path = require('path')
// projectInit
const pro_dir = path.join(__dirname, "./../projectInit" )
//项目目录
const projectPath =  path.join(__dirname, "./../../../" )
// static
const static_dir = path.join(__dirname, "./../static/" )
//上传图片的模板
var multer = require("multer");
var zipper = require("zip-local");


const {
  execSync,
  exec,
  spawn,spawnSync
} = require("child_process");

//生成的图片放入uploads文件夹下
var upload = multer({
  dest: "website/",
});

require("./util/common");

router.post("/create", upload.single("create"), (req, res) => {
  fs.writeFileSync(pro_dir + "/website.json", JSON.stringify(req.body));
  res.send({
    err: 0,
    msg: "ok",
    data:pro_dir
  });
});
//写入代码

router.post("/writeCode", upload.single("writeCode"), (req, res) => {
  execSync("node  node_modules/creat-app-h5page/projectInit/index.js"); //可以执行

  res.send({
    err: 0,
    msg: "ok",
  });
});
// 再执行website 下的 npm install
router.post("/initDependent", upload.single("initDependent"), (req, res) => {
  var workerProcess =execSync("npm run init-website");
  workerProcess.on('exit', function (code) {
    console.log('子进程已退出，退出码 '+code);
});
  res.send({
    err: 0,
    msg: "ok",
  });
});

// 再执行websit下的build
router.post("/build", upload.single("build"), (req, res) => {
  // eg:1
  // var npm = process.platform === 'win32' ? 'npm.cmd' : 'npm'
  // var args = ['run']
  // args.push("build")
  //  spawnSync(npm, args, {
  //   stdio: 'inherit',
  //   cwd: projectPath
  // });
   // eg:2
  execSync("./../../../ & npm run build");
  res.send({
    err: 0,
    msg: "ok",
  });
});
router.post("/send", upload.single("send"), (req, res) => {
  const  _config=  JSON.parse( fs.readFileSync(pro_dir + "/website.json","utf-8" ) );
  const base_url= _config.h5.split(".")[1];
  const name= `${base_url} ${new Date().Format("yyyy-MM-dd")}`
  zipper.sync.zip(projectPath+"/dist").compress().save(static_dir+`${name}.zip`);
  res.send({
    err: 0,
    data:{
      name:name
    },
    msg: "ok",
  });
});

module.exports = router;