/*
 * @Description: Description
 * @Author: ranli
 * @Date: 2020-09-23 17:36:04
 * @LastEditTime: 2022-05-11 15:44:50
 * @LastEditors: ranli
 */
const path = require("path");
const express = require("express");
const opn = require("opn");
const fs = require("fs");
const app = express();
const cors = require("cors");
const bodyParser = require("body-parser");
app.use(
  bodyParser.urlencoded({
    extended: false,
  })
);
app.use(bodyParser.json());
app.use(cors());
// 配置静态资源目录 整一个文件夹 通过域名能访问
app.use(express.static(path.join(__dirname, "./static")));

app.get("/", function (req, res) {
  res.sendFile(path.join(__dirname, "init.html"));
});
app.get("/edit", function (req, res) {
  res.sendFile(path.join(__dirname, "edit.html"));
});
const port = 4000;

//数据模型
//路由配置
const website = require("./router/website.js");
app.use("/website", website);
 
const writePages = require("./router/writePages.js");
app.use("/writePages", writePages);

app.listen(port, () => {
  console.log(`server running at ${port}/`);
});

// opn(`http://localhost:${port}`, { app: 'chrome' });
